package com.sf.vertx.handle;

import io.netty.handler.codec.http.HttpResponseStatus;

public class MockException extends RuntimeException {
	private static final long serialVersionUID = 7975954645547803571L;
	private final int statusCode;
	private final String payload;

	public MockException() {
		this(500, null, null);
	}

	public MockException(int statusCode) {
		this(statusCode, null, null);
	}

	public MockException(int statusCode, Throwable cause) {
		this(statusCode, null, cause);
	}

	public MockException(int statusCode, String payload) {
		this(statusCode, payload, null);
	}

	public MockException(int statusCode, String payload, Throwable cause) {
		super(HttpResponseStatus.valueOf(statusCode).reasonPhrase(), cause, false, false);
		this.statusCode = statusCode;
		this.payload = payload;
	}

	public int getStatusCode() {
		return statusCode;
	}

	public String getPayload() {
		return payload;
	}
}